#include "libelybot_fdcan.h"
#include "my_fdcan.h"
#include <string.h>


FDCAN_RxHeaderTypeDef fdcan_rx_header1;
uint8_t fdcan1_rdata[64] = {0};

motor_state_t motor_state;
uint8_t motor_read_flag = 0;



//static void print_data(uint8_t *data, uint16_t len)
//{
//    for (int i = 0; i < len; i++)
//    {
//        printf("%d\r\n", &data[i]);
//    }
//    printf("\r\n\r\n");
//}


/**
 * @brief ѹ float
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param volt ѹ0.3 -> 0.3v
 */
void set_dq_volt_float(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, float volt)
{
    //                          dqѹģʽ   216λ      d                        q                       ռλfdcan
    static uint8_t cmd[] = {0x01, 0x00, 0x08, 0x0E, 0x1a, 0x00, 0x00, 0x00, 0x00,  0x00, 0x00, 0x00, 0x00, 0x50, 0x50, 0x50};

    *(float *)&cmd[9] = volt;

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ѹ int32
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param volt ѹλ0.001V
 */
void set_dq_volt_int32(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int32_t volt)
{
    //                   		dqѹģʽ   232λ      d                        q                       ռλfdcan
    static uint8_t cmd[] = {0x01, 0x00, 0x08, 0x0A, 0x1a, 0x00, 0x00, 0x00, 0x00,  0x00, 0x00, 0x00, 0x00, 0x50, 0x50, 0x50};

    *(int32_t *)&cmd[9] = volt;

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ѹ int16
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param volt ѹλ0.1V
 */
void set_dq_volt_int16(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int16_t volt)
{
    //                   		dqѹģʽ   216λ      d           q           ռλfdcan
    static uint8_t cmd[] = {0x01, 0x00, 0x08, 0x06, 0x1a, 0x00, 0x00, 0x00, 0x00, 0x50, 0x50, 0x50};

    *(int16_t *)&cmd[7] = volt;

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief  float
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param volt 0.3 -> 0.3A
 */
void set_dq_current_float(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, float current)
{
    //                   		dqģʽ   232λ      q       			  d       			  ռλfdcan
    static uint8_t cmd[] = {0x01, 0x00, 0x09, 0x0E, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x50, 0x50};

    *(float *)&cmd[5] = current;

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief  int32
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param volt λ0.001A
 */
void set_dq_current_int32(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int32_t current)
{
    //                   		dqģʽ   232λ      q       			  d       			   ռλfdcan
    static uint8_t cmd[] = {0x01, 0x00, 0x09, 0x0A, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x50, 0x50};

    *(int32_t *)&cmd[5] = current;

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief  int16
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param volt λ0.1A
 */
void set_dq_current_int16(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int16_t current)
{
    //                   		dqģʽ   216λ      q       d       ռλfdcan
    static uint8_t cmd[] = {0x01, 0x00, 0x09, 0x06, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x50, 0x50, 0x50};

    *(int16_t *)&cmd[5] = current;

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ؿ float
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param torque أλĵ
 */
void set_torque_float(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, float torque)
{
    //                     		  λģʽ    float  6        λ
    static uint8_t cmd[] = {0x01, 0x00, 0x0a, 0x0c, 0x06, 0x20, 0x00, 0x00,
                            // 			ٶ                 	
                            0xc0, 0x7f, 0x00, 0x00, 0x00, 0x00, 0xcd, 0xcc,
                            //			kp                	    kd
                            0xcc, 0x3d, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                            //			                ռλfdcan
                            0x00, 0x00, 0x00, 0x00, 0xc0, 0x7f, 0x50, 0x50
                           };

    *(int32_t *)&cmd[14] = *(int32_t *)&torque;
    // memcpy(&cmd[14], &torque, sizeof(float));

    fdcan_send(fdcanHandle, 0x8000 | id, (uint8_t *)cmd, sizeof(cmd));
}


/**
 * @brief ؿ int32
 * @param fdcanHandle &hfdcanx
 * @param id id ID
 * @param torque أλĵ
 */
void set_torque_int32(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int32_t torque)
{
    //                     λģʽ    		 int32  6    	    λ
    static uint8_t cmd[] = {0x01, 0x00, 0x0a, 0x08, 0x06, 0x20, 0x00, 0x00,
                            //          ٶ                    
                            0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                            //          kp  					kd
                            0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                            //             		 	    ռλfdcan
                            0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x50, 0x50
                           };

    *(int32_t *)&cmd[14] = *(int32_t *)&torque;
    // memcpy(&cmd[14], &torque, sizeof(int32_t));

    fdcan_send(fdcanHandle, 0x8000 | id, (uint8_t *)cmd, sizeof(cmd));
}


/**
 * @brief ؿ int16
 * @param fdcanHandle &hfdcanx
 * @param id id ID
 * @param torque أλĵ
 */
void set_torque_int16(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int16_t torque)
{
    //                     		λģʽ     int16   6        λ
    static uint8_t cmd[] = {0x01, 0x00, 0x0a, 0x04, 0x06, 0x20, 0x00, 0x80,
                            //ٶ              kp          kd              ռλfdcan
                            0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x50, 0x50
                           };

    *(int16_t *)&cmd[10] = *(int16_t *)&torque;
    // memcpy(&cmd[10], &torque, sizeof(int16_t));

    fdcan_send(fdcanHandle, 0x8000 | id, (uint8_t *)cmd, sizeof(cmd));
}


/**
 * @brief λ-ٶ-ǰ()ƣfloat
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param pos λãλ 1 Ȧ pos = 0.5 ʾת 0.5 Ȧλá
 * @param vel ٶȣλ 1 ת/룬 vel = 0.5 ʾ 0.5 ת/
 * @param torque أλĵ
 */
void set_pos_vel_tqe_float(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, float pos, float vel, float torque)
{
    //                           λģʽ     int32       λ                    ٶ                    			                      ֹͣλ                ռλfdcan
    static uint8_t cmd[] = {0x01, 0x00, 0x0a, 0x0e, 0x20, 0x00, 0x00, 0xc0, 0x7f, 0xcd, 0xcc, 0xcc, 0x3d, 0x0e, 0x25, 0x00, 0x00, 0x80, 0x3f, 0x9a, 0x99, 0x00, 0x00, 0x50};

    // *(int32_t *)&cmd[9] = *(int32_t *)&vel;
    // *(int32_t *)&cmd[15] = *(int32_t *)&torque;
    // *(int32_t *)&cmd[19] = *(int32_t *)&pos;

    memcpy(&cmd[9], &vel, sizeof(float));
    memcpy(&cmd[15], &torque, sizeof(float));
    memcpy(&cmd[19], &pos, sizeof(float));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief λ-ٶ-ǰ()ƣint32
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param pos λãλ 0.00001 Ȧ pos = 50000 ʾת 0.5 Ȧλá
 * @param vel ٶȣλ 0.00001 ת/룬 vel = 50000 ʾ 0.5 ת/
 * @param torque أλĵ
 */
void set_pos_vel_tqe_int32(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int32_t pos, int32_t vel, int32_t torque)
{
    //                           λģʽ     int32       λ                    ٶ                    			                      ֹͣλ                ռλfdcan
    static uint8_t cmd[] = {0x01, 0x00, 0x0a, 0x0a, 0x20, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x0a, 0x25, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50};

    // *(int32_t *)&cmd[9] =  vel;
    // *(int32_t *)&cmd[13] = torque;
    // *(int32_t *)&cmd[17] = pos;

    memcpy(&cmd[9], &vel, sizeof(int32_t));
    memcpy(&cmd[15], &torque, sizeof(int32_t));
    memcpy(&cmd[19], &pos, sizeof(int32_t));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief λ-ٶ-ǰ()ƣint16
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param pos λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 * @param vel ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 * @param torque أλĵ
 */
void set_pos_vel_tqe_int16(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int16_t pos, int16_t vel, int16_t torque)
{
    //                            λģʽ   2int16      λ        ٶ		 2int16	                		  
    static uint8_t cmd[] = {0x01, 0x00, 0x0a, 0x06, 0x20, 0x00, 0x80, 0x00, 0x00, 0x06, 0x25, 0x00, 0x00, 0x50, 0x50};

    // *(int16_t *)&cmd[7] =  vel;
    // *(int16_t *)&cmd[11] = torque;
    // *(int16_t *)&cmd[13] = pos;

    memcpy(&cmd[7], &vel, sizeof(int16_t));
    memcpy(&cmd[11], &torque, sizeof(int16_t));
    memcpy(&cmd[13], &pos, sizeof(int16_t));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief λÿ float
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param pos λãλ 1 Ȧ pos = 0.5 ʾת 0.5 Ȧλá
 */
void set_pos_float(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, float pos)
{
    //                           λģʽ   1float      λ                    ռλfdcan
    static uint8_t cmd[] = {0x01, 0x00, 0x0A, 0x0D, 0x20, 0x00, 0x00, 0x00, 0x00, 0x50, 0x50, 0x50};

    memcpy(&cmd[5], &pos, sizeof(float));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief λÿ int32
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param pos λãλ 0.00001 Ȧ pos = 50000 ʾת 0.5 Ȧλá
 */
void set_pos_int32(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int32_t pos)
{
    //                           λģʽ   1int32      λ                    ռλfdcan
    static uint8_t cmd[] = {0x01, 0x00, 0x0A, 0x09, 0x20, 0x00, 0x00, 0x00, 0x00, 0x50, 0x50, 0x50};

    memcpy(&cmd[5], &pos, sizeof(int32_t));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief λÿ int16
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param pos λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 */
void set_pos_int16(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int16_t pos)
{
    //                          λģʽ     1int16     λ
    static uint8_t cmd[] = {0x01, 0x00, 0x0A, 0x05, 0x20, 0x00, 0x00};

    memcpy(&cmd[5], &pos, sizeof(int16_t));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ٶȿ float
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param vel ٶȣλ 1 ת/룬 vel = 0.1 -> 0.1 ת/
 */
void set_vel_float(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, float vel)
{
    //							  λģʽ     2float 	λ					ٶ					ռλfdcan
    static uint8_t cmd[16] = {0x01, 0x00, 0x0A, 0x0E, 0x20, 0x00, 0x00, 0xc0, 0x7f, 0x00, 0x00, 0x00, 0x00, 0x50, 0x50, 0x50};

    memcpy(&cmd[9], &vel, sizeof(float));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ٶȿ int32
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param vel ٶȣλ 0.00001 ת/룬 vel = 50000 ʾ 0.5 ת/
 */
void set_vel_int32(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int32_t vel)
{
    //							  λģʽ     2int32 	λ					ٶ					ռλfdcan
    static uint8_t cmd[16] = {0x01, 0x00, 0x0A, 0x0A, 0x20, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x50, 0x50, 0x50};

    memcpy(&cmd[9], &vel, sizeof(int32_t));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ٶȿ int16
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param vel ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 */
void set_vel_int16(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int16_t vel)
{
    //							λģʽ     2int16 	  λ		  ٶ		  ռλfdcan
    static uint8_t cmd[] = {0x01, 0x00, 0x0A, 0x06, 0x20, 0x00, 0x80, 0x00, 0x00, 0x50, 0x50, 0x50};

    memcpy(&cmd[7], &vel, sizeof(int16_t));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief λáٶȡǰءKpKd float  ( = λƫ * Mkp + ٶƫ * Mkd + ǰ) (Mkp ʾڲ kp, Mkd ʾڲ kd)
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param pos λãλ 1 Ȧ pos = 0.5 ʾת 0.5 Ȧλá
 * @param vel ٶȣλ 1 ת/룬 vel = 0.5 ʾ 0.5 ת/
 * @param tqe ǰأλĵ
 * @param kp Mkp = kp * 1 (Mkp ʾڲ kp)
 * @param kd Mkd = kp * 1 (Mkd ʾڲ kd)
 */
void set_pos_vel_tqe_pd_float(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, float pos, float vel, float tqe, float kp, float kd)
{
    static uint8_t cmd[] = {
    0x01, 0x00, 0x0A,
    0x0f, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x0e, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x50, 0x50, 0x50, 0x50, 0x50
    };

    memcpy(&cmd[5], &pos, sizeof(float));
    memcpy(&cmd[9], &vel, sizeof(float));
    memcpy(&cmd[13], &tqe, sizeof(float));
    memcpy(&cmd[19], &kp, sizeof(float));
    memcpy(&cmd[23], &kd, sizeof(float));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief λáٶȡǰءKpKd int32 ( = λƫ * Mkp + ٶƫ * Mkd + ǰ) (Mkp ʾڲ kp, Mkd ʾڲ kd)
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param pos λãλ 0.00001 Ȧ pos = 50000 ʾת 0.5 Ȧλ
 * @param vel ٶȣλ 0.00001 ת/룬 vel = 50000 ʾ 0.5 ת/
 * @param tqe ǰأλĵ
 * @param kp Mkp = kp * 0.001 (Mkp ʾڲ kp)
 * @param kd Mkd = kp * 0.001 (Mkd ʾڲ kd)
 */
void set_pos_vel_tqe_pd_int32(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int32_t pos, int32_t vel, int32_t tqe, int32_t kp, int32_t kd)
{
    static uint8_t cmd[] = {
    0x01, 0x00, 0x0A,
    0x0B, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x0A, 0x2b, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x50, 0x50, 0x50, 0x50, 0x50
    };
    
    memcpy(&cmd[5], &pos, sizeof(float));
    memcpy(&cmd[9], &vel, sizeof(float));
    memcpy(&cmd[13], &tqe, sizeof(float));
    memcpy(&cmd[19], &kp, sizeof(float));
    memcpy(&cmd[23], &kd, sizeof(float));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, 48);
}


/**
 * @brief λáٶȡǰءKpKd int16 ( = λƫ * Mkp + ٶƫ * Mkd + ǰ) (Mkp ʾڲ kp, Mkd ʾڲ kd)
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param pos λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 * @param vel ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 * @param tqe ǰأλĵ
 * @param kp Mkp = kp * 0.1 (Mkp ʾڲ kp)
 * @param kd Mkd = kp * 0.1 (Mkd ʾڲ kd)
 */
void set_pos_vel_tqe_pd_int16(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int16_t pos, int16_t vel, int16_t tqe, int16_t kp, int16_t kd)
{
    static uint8_t cmd[] = {
    0x01, 0x00, 0x0A,
    0x07, 0x20, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
    0x06, 0x2b, 0x00, 0x00, 0x00, 0x00,
    0x50, 0x50, 0x50
    };

    memcpy(&cmd[5], &pos, sizeof(int16_t));
    memcpy(&cmd[7], &vel, sizeof(int16_t));
    memcpy(&cmd[9], &tqe, sizeof(int16_t));
    memcpy(&cmd[13], &kp, sizeof(int16_t));
    memcpy(&cmd[15], &kd, sizeof(int16_t));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ٶȡٶ޷ƣ vel > vel_max vel_max int16
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param vel ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 * @param vel_max ٶ޷λ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 */
void set_vel_velmax_int16(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int16_t vel, int16_t vel_max)
{
    //							λģʽ				  λ        ٶ		  			  ٶ
    static uint8_t cmd[] = {0x01, 0x00, 0x0A, 0x06, 0x20, 0x00, 0x80, 0x00, 0x00, 0x05, 0x28, 0x00, 0x00, 0x50, 0x50, 0x50};

    memcpy(&cmd[11], &vel_max, sizeof(int16_t));
    memcpy(&cmd[7], &vel, sizeof(int16_t));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief λáٶȡٶƣοƣ float
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param pos λãλ 1 Ȧ pos = 0.5 ʾת 0.5 Ȧλá
 * @param vel_max ٶƣλ 1 ת/룬 vel = 0.5 ʾ 0.5 ת/
 * @param acc ٶȣλ1 ת/^2
 */
void set_pos_velmax_acc_float(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, float pos, float vel_max, float acc)
{
    // 							λģʽ				  λ		  						  ٶ
    static uint8_t cmd[] = {0x01, 0x00, 0x0A, 0x0D, 0x20, 0x00, 0x00, 0x00, 0x80, 0x0E, 0x28, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50};

    memcpy(&cmd[5], &pos, sizeof(float));
    memcpy(&cmd[11], &vel_max, sizeof(float));
    memcpy(&cmd[15], &acc, sizeof(float));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief λáٶȡٶƣοƣ int32
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param pos λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλ
 * @param vel_max ٶƣλ 0.00001 ת/룬 vel = 50000 ʾ 0.5 ת/
 * @param acc ٶȣλ 0.00001 ת/^2 acc = 50000 ʾ 0.5 ת/^2
 */
void set_pos_velmax_acc_int32(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int32_t pos, int32_t vel_max, int32_t acc)
{
    // 							λģʽ				  λ		  						  ٶ
    static uint8_t cmd[] = {0x01, 0x00, 0x0A, 0x09, 0x20, 0x00, 0x00, 0x00, 0x80, 0x0A, 0x28, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50};

    memcpy(&cmd[5], &pos, sizeof(int32_t));
    memcpy(&cmd[11], &vel_max, sizeof(int32_t));
    memcpy(&cmd[15], &acc, sizeof(int32_t));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief λáٶȡٶƣοƣ int16
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param pos λãλ 0.00001 Ȧ pos = 50000 ʾת 0.5 Ȧλ
 * @param vel_max ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 * @param acc ٶȣλ 0.00025 ת/^2 acc = 400 ʾ 0.1 ת/^2
 */
void set_pos_velmax_acc_int16(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int16_t pos, int16_t vel_max, int16_t acc)
{
    // 							λģʽ				  λ		  ٶ
    static uint8_t cmd[] = {0x01, 0x00, 0x0A, 0x05, 0x20, 0x00, 0x80, 0x06, 0x28, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00};

    memcpy(&cmd[5], &pos, sizeof(int16_t));
    memcpy(&cmd[9], &vel_max, sizeof(int16_t));
    memcpy(&cmd[11], &acc, sizeof(int16_t));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ٶȡٶȿ float
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param vel ٶȣλ 1 ת/룬 vel = 0.5 ʾ 0.5 ת/
 * @param acc ٶȣλ1 ת/^2
 */
void set_vel_acc_float(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, float vel, float acc)
{
    //							λģʽ				  λ					  ٶ								  ٶ
    static uint8_t cmd[] = {0x01, 0x00, 0x0A, 0x0E, 0x20, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x80, 0x0D, 0x29, 0x00, 0x00, 0x00, 0x00, 0x50, 0x00, 0x50, 0x50, 0x50};

    memcpy(&cmd[9], &vel, sizeof(float));
    memcpy(&cmd[15], &acc, sizeof(float));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ٶȡٶȿ int32
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param vel ٶȣλ 0.00001 ת/룬 vel = 50000 ʾ 0.5 ת/
 * @param acc ٶȣλ 0.001 ת/^2 vel = 500 ʾ 0.5 ת/^2
 */
void set_vel_acc_int32(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int32_t vel, int32_t acc)
{
    //							λģʽ				  λ					  ٶ								  ٶ
    static uint8_t cmd[] = {0x01, 0x00, 0x0A, 0x0A, 0x20, 0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x80, 0x09, 0x29, 0x00, 0x00, 0x00, 0x00, 0x00, 0x50, 0x50, 0x50, 0x50};

    memcpy(&cmd[9], &vel, sizeof(int32_t));
    memcpy(&cmd[15], &acc, sizeof(int32_t));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ٶȡٶȿ int16
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param vel ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 * @param acc ٶȣλ 0.01 ת/^2 vel = 40 ʾ 0.4 ת/^2
 */
void set_vel_acc_int16(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int16_t vel, int16_t acc)
{
    //							λģʽ				  λ		  ٶ					  ٶ
    static uint8_t cmd[] = {0x01, 0x00, 0x0A, 0x06, 0x20, 0x00, 0x80, 0x00, 0x00, 0x05, 0x29, 0x00, 0x00, 0x50, 0x50, 0x50};

    memcpy(&cmd[7], &vel, sizeof(int16_t));
    memcpy(&cmd[11], &acc, sizeof(int16_t));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ʹõѹģʽ̶ᶯڼٵֹͣǵ
 * @param fdcanHandle &hfdcanx
 * @param id ID
 * @param vol dѹ
 */
void set_vfoc_lock_int16(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int16_t vol)
{
    static uint8_t cmd[] = {0x01, 0x00, 0x12, 0x05, 0x19, 0x00, 0x00};

    memcpy(&cmd[5], &vol, sizeof(int16_t));

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ڷصλáٶȡ(ݸʽʹ 0x170x01 ָȡĸʽһ)
 *          1. ڷصλáٶȡݡ
 *          2. ݸʽʹ  0x170x01  ָȡĸʽһ
 *          3. ڵλΪ ms
 *          4. СΪ 1ms 32767ms
 *          5. ֹͣڷݣڸ 0 ɣ߸ϵ硣
 * @param id ID
 * @param t ڣλms
 */
void timed_return_motor_status_int16(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id, int16_t t_ms)
{
    static uint8_t tdata[] = {0x05, 0xb4, 0x02, 0x00, 0x00};

    *(int16_t *)&tdata[3] = t_ms;

    fdcan_send(fdcanHandle, 0x8000 | id, tdata, sizeof(tdata));
}


/**
 * @brief һ϶ λÿ int16 
 * @param fdcanHandle &hfdcanx
 * @param pos1 1λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 * @param pos2 2λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 * @param pos3 3λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 * @param pos4 4λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 */
void set_many_pos_int16(FDCAN_HandleTypeDef *fdcanHandle, int16_t pos1, int16_t pos2, int16_t pos3, int16_t pos4)
{
    static uint8_t cmd[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x01};

    memcpy(&cmd[0], &pos1, sizeof(int16_t));
    memcpy(&cmd[2], &pos2, sizeof(int16_t));
    memcpy(&cmd[4], &pos3, sizeof(int16_t));
	memcpy(&cmd[5], &pos4, sizeof(int16_t));

    fdcan_send(fdcanHandle, MODE_POSITION, cmd, sizeof(cmd));
}


/**
 * @brief һ϶ ٶȿ int16
 * @param fdcanHandle &hfdcanx
 * @param pos1 1ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 * @param pos2 2ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 * @param pos3 3ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 * @param pos4 4ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 */
void set_many_vel_int16(FDCAN_HandleTypeDef *fdcanHandle, int16_t vel1, int16_t vel2, int16_t vel3, int16_t vel4)
{
    static uint8_t cmd[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x01};

    memcpy(&cmd[0], &vel1, sizeof(int16_t));
    memcpy(&cmd[2], &vel2, sizeof(int16_t));
    memcpy(&cmd[4], &vel3, sizeof(int16_t));
	memcpy(&cmd[5], &vel4, sizeof(int16_t));

    fdcan_send(fdcanHandle, MODE_VELOCITY, cmd, sizeof(cmd));
}


/**
 * @brief һ϶ ؿ int16
 * @param fdcanHandle &hfdcanx
 * @param tqe1 1أλĵ
 * @param tqe2 2أλĵ
 * @param tqe3 3أλĵ
 * @param tqe4 4أλĵ
 */
void set_many_tqe_int16(FDCAN_HandleTypeDef *fdcanHandle, int16_t tqe1, int16_t tqe2, int16_t tqe3, int16_t tqe4)
{
    static uint8_t cmd[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x01};

    memcpy(&cmd[0], &tqe1, sizeof(int16_t));
    memcpy(&cmd[2], &tqe2, sizeof(int16_t));
    memcpy(&cmd[4], &tqe3, sizeof(int16_t));
	memcpy(&cmd[5], &tqe4, sizeof(int16_t));

    fdcan_send(fdcanHandle, MODE_TORQUE, cmd, sizeof(cmd));
}


/**
 * @brief һ϶ DQѹ int16
 * @param fdcanHandle &hfdcanx
 * @param volt1 1qѹλ0.1V
 * @param volt2 2qѹλ0.1V
 * @param volt3 3qѹλ0.1V
 * @param volt4 4qѹλ0.1V
 */
void set_many_volt_int16(FDCAN_HandleTypeDef *fdcanHandle, int16_t volt1, int16_t volt2, int16_t volt3, int16_t volt4)
{
    static uint8_t cmd[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x01};

    memcpy(&cmd[0], &volt1, sizeof(int16_t));
    memcpy(&cmd[2], &volt2, sizeof(int16_t));
    memcpy(&cmd[4], &volt3, sizeof(int16_t));
	memcpy(&cmd[5], &volt4, sizeof(int16_t));

    fdcan_send(fdcanHandle, MODE_VOLTAGE, cmd, sizeof(cmd));
}


/**
 * @brief һ϶ DQ int16
 * @param fdcanHandle &hfdcanx
 * @param current1 1qλ0.1A
 * @param current2 2qλ0.1A
 * @param current3 3qλ0.1A
 * @param current4 4qλ0.1A
 */
void set_many_current_int16(FDCAN_HandleTypeDef *fdcanHandle, int16_t current1, int16_t current2, int16_t current3, int16_t current4)
{
    static uint8_t cmd[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x01};

    memcpy(&cmd[0], &current1, sizeof(int16_t));
    memcpy(&cmd[2], &current2, sizeof(int16_t));
    memcpy(&cmd[4], &current3, sizeof(int16_t));
	memcpy(&cmd[5], &current4, sizeof(int16_t));

    fdcan_send(fdcanHandle, MODE_CURRENT, cmd, sizeof(cmd));
}


/**
 * @brief һ϶ λáٶȡؿ int16
 * @param fdcanHandle &hfdcanx
 * @param pos1 1λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 * @param vel1 1ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 * @param tqe1 1أλĵ
 * @param pos2 2λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 * @param vel2 2ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 * @param tqe2 2أλĵ
 */
void set_many_pos_vel_tqe_int16(FDCAN_HandleTypeDef *fdcanHandle, int16_t pos1, int16_t vel1, int16_t tqe1, int16_t pos2, int16_t vel2, int16_t tqe2)
{
    static uint8_t cmd[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x01};

    memcpy(&cmd[0], &pos1, sizeof(int16_t));
    memcpy(&cmd[2], &vel1, sizeof(int16_t));
    memcpy(&cmd[4], &tqe1, sizeof(int16_t));
    
    memcpy(&cmd[6], &pos2, sizeof(int16_t));
    memcpy(&cmd[8], &vel2, sizeof(int16_t));
    memcpy(&cmd[10], &tqe2, sizeof(int16_t));

    fdcan_send(fdcanHandle, MODE_POS_VEL_TQE, cmd, sizeof(cmd));
}


/**
 * @brief һ϶ λáٶȡءPD int16
 * @param fdcanHandle &hfdcanx
 * @param pos1 1λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 * @param vel1 1ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 * @param tqe1 1أλĵ
 * @param rkp1 1 Kp 
 * @param rkd1 1 Kd 
 * @param pos2 2λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 * @param vel2 2ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 * @param tqe2 2أλĵ
 * @param rkp2 2 Kp 
 * @param rkd2 2 Kd 
 */
void set_many_pos_vel_tqe_pd_int16(FDCAN_HandleTypeDef *fdcanHandle, int16_t pos1, int16_t vel1, int16_t tqe1, int16_t rkp1, int16_t rkd1, int16_t pos2, int16_t vel2, int16_t tqe2, int16_t rkp2, int16_t rkd2)
{
    static uint8_t cmd[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x01};

    memcpy(&cmd[0], &pos1, sizeof(int16_t));
    memcpy(&cmd[2], &vel1, sizeof(int16_t));
    memcpy(&cmd[4], &tqe1, sizeof(int16_t));
    memcpy(&cmd[6], &rkp1, sizeof(int16_t));
    memcpy(&cmd[8], &rkd1, sizeof(int16_t));
    memcpy(&cmd[10], &pos2, sizeof(int16_t));
    memcpy(&cmd[12], &vel2, sizeof(int16_t));
    memcpy(&cmd[14], &tqe2, sizeof(int16_t));
    memcpy(&cmd[16], &rkp2, sizeof(int16_t));
    memcpy(&cmd[18], &rkd2, sizeof(int16_t));

    fdcan_send(fdcanHandle, MODE_POS_VEL_TQE_KP_KD, cmd, sizeof(cmd));
}


/**
 * @brief һ϶ λáٶȡPD int16
 * @param fdcanHandle &hfdcanx
 * @param pos1 1λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 * @param vel1 1ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 * @param rkp1 1 Kp 
 * @param rkd1 1 Kd 
 * @param pos2 2λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 * @param vel2 2ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 * @param rkp2 2 Kp 
 * @param rkd1 2 Kd 
 */
void set_many_pos_vel_pd_int16(FDCAN_HandleTypeDef *fdcanHandle, int16_t pos1, int16_t vel1, int16_t rkp1, int16_t rkd1, int16_t pos2, int16_t vel2, int16_t rkp2, int16_t rkd2)
{
    static uint8_t cmd[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x01};

    memcpy(&cmd[0], &pos1, sizeof(int16_t));
    memcpy(&cmd[2], &vel1, sizeof(int16_t));
    memcpy(&cmd[4], &rkp1, sizeof(int16_t));
    memcpy(&cmd[6], &rkd1, sizeof(int16_t));
    
    memcpy(&cmd[8], &pos2, sizeof(int16_t));
    memcpy(&cmd[10], &vel2, sizeof(int16_t));
    memcpy(&cmd[12], &rkp2, sizeof(int16_t));
    memcpy(&cmd[14], &rkd2, sizeof(int16_t));

    fdcan_send(fdcanHandle, MODE_POS_VEL_KP_KD, cmd, sizeof(cmd));
}



/**
 * @brief һ϶ λáٶȡٶȿ int16
 * @param fdcanHandle &hfdcanx
 * @param pos1 1λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 * @param vel1 1ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 * @param acc1 1ļٶȣλ 0.01 ת/^2 vel = 40 ʾ 0.4 ת/^2
 * @param pos2 2λãλ 0.0001 Ȧ pos = 5000 ʾת 0.5 Ȧλá
 * @param vel2 2ٶȣλ 0.00025 ת/룬 vel = 400 ʾ 0.1 ת/
 * @param acc2 2ļٶȣλ 0.01 ת/^2 vel = 40 ʾ 0.4 ת/^2
 */
void set_many_pos_vel_acc_int16(FDCAN_HandleTypeDef *fdcanHandle, int16_t pos1, int16_t vel1, int16_t acc1, int16_t pos2, int16_t vel2, int16_t acc2)
{
    static uint8_t cmd[] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x17, 0x01};

    memcpy(&cmd[0], &pos1, sizeof(int16_t));
    memcpy(&cmd[2], &vel1, sizeof(int16_t));
    memcpy(&cmd[4], &acc1, sizeof(int16_t));
    
    memcpy(&cmd[6], &pos2, sizeof(int16_t));
    memcpy(&cmd[8], &vel2, sizeof(int16_t));
    memcpy(&cmd[10], &acc2, sizeof(int16_t));

    fdcan_send(fdcanHandle, MODE_POS_VEL_ACC, cmd, sizeof(cmd));
}


/**
 * @brief λ
 * @param fdcanHandle &hfdcanx
 * @param id id ID
 */
void set_pos_rezero(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id)
{
    static uint8_t cmd[] = {0x40, 0x01, 0x15, 0x64, 0x20, 0x63, 0x66, 0x67, 0x2d, 0x73, 0x65, 0x74, 0x2d, 0x6f, 0x75, 0x74, 0x70, 0x75, 0x74, 0x20, 0x30, 0x2e, 0x30, 0x0a};

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));

    HAL_Delay(1000);

    set_conf_write(fdcanHandle, 1);
}


/**
 * @brief 
 * @param fdcanHandle &hfdcanx
 * @param id id ID
 */
void set_conf_write(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id)
{
    static uint8_t cmd[] = {0x40, 0x01, 0x0B, 0x63, 0x6F, 0x6E, 0x66, 0x20, 0x77, 0x72, 0x69, 0x74, 0x65, 0x0A, 0x50, 0x50};

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ֹͣע⣺õֹͣλЧ
 * @param fdcanHandle &hfdcanx
 * @param id id ID
 */
void set_motor_stop(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id)
{
    static uint8_t cmd[] = {0x01, 0x00, 0x00};

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ɲ
 * @param fdcanHandle &hfdcanx
 * @param id id ID
 */
void set_motor_brake(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id)
{
    static uint8_t cmd[] = {0x01, 0x00, 0x0f};

    fdcan_send(fdcanHandle, 0x8000 | id, cmd, sizeof(cmd));
}


/**
 * @brief ȡ״̬ float״̬λáٶȡת
 * @param fdcanHandle &hfdcanx
 * @param id id ID
 */
void read_motor_state_float(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id)
{
    const uint8_t cmd[] = {0x1C, 0x04, 0x00};

    fdcan_send(fdcanHandle, 0x8000 | id, (uint8_t *)cmd, sizeof(cmd));
}


/**
 * @brief ȡ״̬ int32״̬λáٶȡת
 * @param fdcanHandle &hfdcanx
 * @param id id ID
 */
void read_motor_state_int32(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id)
{
    const uint8_t cmd[] = {0x18, 0x04, 0x00};

    fdcan_send(fdcanHandle, 0x8000 | id, (uint8_t *)cmd, sizeof(cmd));
}


/**
 * @brief ȡ״̬ int16״̬λáٶȡת
 * @param fdcanHandle &hfdcanx
 * @param id id ID
 */
void read_motor_state_int16(FDCAN_HandleTypeDef *fdcanHandle, uint8_t id)
{
    const uint8_t cmd[] = {0x14, 0x04, 0x00};

    fdcan_send(fdcanHandle, 0x8000 | id, (uint8_t *)cmd, sizeof(cmd));
}


void HAL_FDCAN_RxFifo0Callback(FDCAN_HandleTypeDef *hfdcan, uint32_t RxFifo0ITs)
{
    uint8_t len = 0;
    if(hfdcan->Instance == FDCAN1 || hfdcan->Instance == FDCAN2 || hfdcan->Instance == FDCAN3)
    {
        HAL_FDCAN_GetRxMessage(hfdcan, FDCAN_RX_FIFO0, &fdcan_rx_header1, fdcan1_rdata);
        if (fdcan_rx_header1.DataLength != 0)
        {

            len = get_fdcan_data_size(fdcan_rx_header1.DataLength);
            motor_state.motor.id = fdcan_rx_header1.Identifier;  // ȡ id
#if READ_MOTOR_FLAG == 1 || READ_MOTOR_FLAG == 2 || READ_MOTOR_FLAG == 3
            memcpy(&motor_state.data[0], &fdcan1_rdata[3], len - 3);  // ȡ״̬
#endif
            motor_read_flag = 1;
        }
    }
}



